(* constructing the various algorithms *)

module NAIVE_BFS = Equivalence.Make(ID)(Queues.BFS)
module HK_BFS = Equivalence.Make(UF.UF)(Queues.BFS)
module HKCRW_BFS = Equivalence.Make(ACI.RW)(Queues.BFS)
module HKCTRW_BFS = Equivalence.Make(ACI.TRW)(Queues.BFS)
module HKCRW'_BFS = Equivalence.Make'(ACI.RW'(Queues.BFS))
module HKCTRW'_BFS = Equivalence.Make'(ACI.TRW'(Queues.BFS))
                   
module NAIVE_DFS = Equivalence.Make(ID)(Queues.DFS)
module HK_DFS = Equivalence.Make(UF.UF)(Queues.DFS)
module HKCRW_DFS = Equivalence.Make(ACI.RW)(Queues.DFS)
module HKCTRW_DFS = Equivalence.Make(ACI.TRW)(Queues.DFS)
module HKCRW'_DFS = Equivalence.Make'(ACI.RW'(Queues.DFS))
module HKCTRW'_DFS = Equivalence.Make'(ACI.TRW'(Queues.DFS))
